#
# spec file for package cyrus-imapd (Version 2.0.16)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  autoconf automake cyrus-sasl cyrus-sasl-devel db-devel des drac ed heimdal-lib openssl openssl-devel yacc
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib cyrus-sasl-devel db-devel des drac ed gcc gdbm gettext heimdal-lib libtool libz openssl openssl-devel pam perl rpm yacc

Name:         cyrus-imapd
License:      BSD, Other License(s), see package
Group:        Productivity/Networking/Email/Servers
Provides:     cyrus-imapd
Requires:     perl-Cyrus-IMAP perl-Cyrus-SIEVE-acap perl-Cyrus-SIEVE-managesieve
Autoreqprov:  on
Summary:      An IMAP/POP Mailserver
Version:      2.0.16
Release:      361
Source:       %{name}-%{version}.tar.bz2
Source1:      SuSE.tar.gz
Patch:        %{name}-%{version}.dif
Patch1:       drac_auth.patch.bz2
Patch2:       allow_auth_plain_proxying.patch
Patch3:       authid_normalize.patch
Patch4:       sieve_dotstuffing_fix.patch
Patch5:       ipurge_force_all.patch
Patch6:       fhs_enable.patch
Patch7:       cyrus-imapd-db4.dif
Patch8:       sieve_parse_header.patch
Patch9:       imap-pre-login-exploit-fix.patch
Patch10:      sieve-exploit-fix.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%package -n perl-Cyrus-IMAP
Summary:      IMAP perl module from cyrus
Autoreqprov:  on
Group:        Development/Libraries/Perl
%package -n perl-Cyrus-SIEVE-acap
Summary:      perl module for cyrus SIEVE ACAP
Autoreqprov:  on
Group:        Development/Libraries/Perl
%package -n perl-Cyrus-SIEVE-managesieve
Summary:      perl modul for cyrus SIEVE
Autoreqprov:  on
Group:        Development/Libraries/Perl
%package -n cyrus-imapd-devel
Summary:      Libraries and includes for cyrus imapd
Autoreqprov:  on
Group:        Development/Libraries/C and C++

%description
The Cyrus IMAP Server.

Authors:
--------
    Office of Technology Transfer Carnegie Mellon University <tech-transfer@andrew.cmu.edu>

SuSE series: n


%description -n perl-Cyrus-IMAP
IMAP perl module from cyrus for the cyrus imapd

Authors:
--------
    Office of Technology Transfer Carnegie Mellon University <tech-transfer@andrew.cmu.edu>

SuSE series: perl


%description -n perl-Cyrus-SIEVE-acap
perl module for cyrus SIEVE ACAP

Authors:
--------
    Office of Technology Transfer Carnegie Mellon University <tech-transfer@andrew.cmu.edu>

SuSE series: perl


%description -n perl-Cyrus-SIEVE-managesieve
perl modul for cyrus SIEVE

Authors:
--------
    Office of Technology Transfer Carnegie Mellon University <tech-transfer@andrew.cmu.edu>

SuSE series: perl


%description -n cyrus-imapd-devel
Libraries and includes for cyrus imapd

Authors:
--------
    Office of Technology Transfer Carnegie Mellon University <tech-transfer@andrew.cmu.edu>

SuSE series: n

%prep
%setup -n %{name}-%{version} -a 1
%patch1 -p 1
%patch -p 1
%patch2 -p 1
%patch3 -p 1
%patch4 -p 1
%patch5 -p 1
%patch6 -p 1
%patch7 -p 1
%patch8 -p 1
%patch9
%patch10

%build
%{?suse_update_config:%{suse_update_config -l -f build}}
rm -f sieve/sieve.c sieve/addr.c
autoconf
./configure --prefix=/usr \
	    --mandir=%{_mandir} \
            --with-cyrus-user=cyrus \
            --with-cyrus-group=mail \
            --with-cyrus-prefix=/usr/lib/cyrus \
	    --localstatedir=/var/lib \
            --without-notify \
            --with-sasldir=/usr \
            --enable-netscapehack \
            --with-openssl=/usr/ssl \
            --with-auth=unix \
	    --with-dbdir=/usr/lib \
	    --enable-shared \
	    --with-drac=/usr/lib
make depend
make CFLAGS="-O2 -fPIC -I/usr/lib/sasl/include -DDRAC_AUTH"

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
# perl modules
# Cyrus IMAP
#*****************************************************************************
cd perl/imap
eval `perl -V:installarchlib`
install -d $RPM_BUILD_ROOT/$installarchlib
make PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 \
	install
install -d $RPM_BUILD_ROOT/var/adm/perl-modules
cat $RPM_BUILD_ROOT/$installarchlib/perllocal.pod | sed "s@$RPM_BUILD_ROOT@@g" > $RPM_BUILD_ROOT/var/adm/perl-modules/perl-Cyrus-IMAP
cd -
#*****************************************************************************
# Cyrus SIEVE acap
#*****************************************************************************
cd perl/sieve/acap
eval `perl -V:installarchlib`
install -d $RPM_BUILD_ROOT/$installarchlib
make PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 \
	install
install -d $RPM_BUILD_ROOT/var/adm/perl-modules
cat $RPM_BUILD_ROOT/$installarchlib/perllocal.pod | sed "s@$RPM_BUILD_ROOT@@g" > $RPM_BUILD_ROOT/var/adm/perl-modules/perl-Cyrus-SIEVE-acap
cd -
#*****************************************************************************
# Cyrus SIEVE managesieve
#*****************************************************************************
cd perl/sieve/managesieve
eval `perl -V:installarchlib`
install -d $RPM_BUILD_ROOT/$installarchlib
make PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 \
	install
install -d $RPM_BUILD_ROOT/var/adm/perl-modules
cat $RPM_BUILD_ROOT/$installarchlib/perllocal.pod | sed "s@$RPM_BUILD_ROOT@@g" > $RPM_BUILD_ROOT/var/adm/perl-modules/perl-Cyrus-SIEVE-managesieve
cd -
#*****************************************************************************
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/var/adm
install -g root -m 755 -o root SuSE/rc.cyrus $RPM_BUILD_ROOT/etc/init.d/cyrus
ln -sf ../etc/init.d/cyrus $RPM_BUILD_ROOT/sbin/rccyrus
export DESTDIR=$RPM_BUILD_ROOT
make install
install -m 644 SuSE/imapd.conf $RPM_BUILD_ROOT/etc/imapd.conf
install -m 644 SuSE/cyrus.conf $RPM_BUILD_ROOT/etc/cyrus.conf
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/deliverdb/db
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/user
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/quota
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/proc
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/log
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/msg
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/db
install -d -m 750 $RPM_BUILD_ROOT/var/lib/imap/socket
install -d -m 750 $RPM_BUILD_ROOT/var/lib/sieve
for i in a b c d e f g h i j k l m n o p q r s t u v w x y z; do
	install -d -m 755 $RPM_BUILD_ROOT/var/lib/imap/user/$i
	install -d -m 755 $RPM_BUILD_ROOT/var/lib/imap/quota/$i
	install -d -m 750 $RPM_BUILD_ROOT/var/lib/sieve/$i
done
chown -R cyrus.mail $RPM_BUILD_ROOT/var/lib/imap
chown -R cyrus.mail $RPM_BUILD_ROOT/var/lib/sieve
install -d -m 750 $RPM_BUILD_ROOT/var/spool/imap
chown cyrus.mail $RPM_BUILD_ROOT/var/spool/imap
mv $RPM_BUILD_ROOT/%{_mandir}/man8/master.8 \
	$RPM_BUILD_ROOT/%{_mandir}/man8/cyrus_master.8

%post
grep -E "^sieve" etc/services >/dev/null || {
   echo "Adding sieve service to /etc/services"
   CFBAK=services.`date +%Y-%m-%d`
   CFNEW=services.$$
   cat etc/services | awk '
BEGIN                   { OFS="\t"; ORS="\n"; }
/^#/                    { print; next; }
/2222\/(tcp|udp)/       { printf "sieve\t\t%s\t# Cyrus SIEVE\n", $2; next; } 
                        { print; next; };' > etc/$CFNEW
   echo "Backing up old services as $CFBAK"
   cp --remove-destination etc/services etc/$CFBAK
   mv etc/$CFNEW etc/services
}
unset SIEVEUP
unset IMAPUP
test $1 -gt 1 && test -d usr/sieve -a ! -L usr/sieve && SIEVEUP=yes
test $1 -gt 1 && test -d var/imap  -a ! -L var/imap  && IMAPUP=yes
test -n "`find var/lib/sieve -type f`" && {
     echo "/var/lib/sieve is not empty"
     unset SIEVEUP
}
test -n "`find var/lib/imap -type f`" && {
     echo "/var/lib/imap is not empty"
     unset IMAPUP
}
test -n "$SIEVEUP" && {
     echo "Creating compatibility symlink /var/lib/sieve -> /usr/sieve"
     rm -rf var/lib/sieve
     ln -sf ../../usr/sieve var/lib/sieve
}
test -n "$IMAPUP" && {
     echo "Creating compatibility symlink /var/lib/imap -> /var/imap"
     rm -rf var/lib/imap
     ln -sf  ../imap /var/lib/imap
}
mkdir -p var/adm/notify/messages
cat << EOF > var/adm/notify/messages/cyrus-notify
ATTENTION!!!
------------
To be compliant to FHS, the following paths have changed:
/usr/cyrus -> /usr/lib/cyrus
/usr/sieve -> /var/lib/sieve
/var/imap  -> /var/lib/imap
If you made an update, you will find the symlinks
   /var/lib/imap  pointing to /var/imap
   /var/lib/sieve pointing to /usr/sieve
It is recommended to move these directories to the new location
manually to prevent further problems.
*****************************************************************************
ACHTUNG!!!
----------
Um dem FHS zu entsprechen, wurden folgende Pfade geaendert:
/usr/cyrus -> /usr/lib/cyrus
/usr/sieve -> /var/lib/sieve
/var/imap  -> /var/lib/imap
Wenn Sie ein Update durchgefuehrt haben, finden Sie folgende
Symbolischen Links:
   /var/lib/imap  zeigt auf /var/imap
   /var/lib/sieve zeigt auf /usr/sieve
Es ist empfehlenswert, diese Verzeichnisse an die neue Stelle zu
verschieben, um spaetere Probleme zu vermeiden.
EOF
mount | grep "`df . | sed -n \\$p | cut -d' ' -f1`" | grep reiserfs > /dev/null || {
        chroot . /usr/bin/chattr +S var/lib/imap
        chroot . /usr/bin/chattr +S var/lib/imap/user
        chroot . /usr/bin/chattr +S var/lib/imap/user/*
        chroot . /usr/bin/chattr +S var/lib/imap/quota
        chroot . /usr/bin/chattr +S var/lib/imap/quota/*
}
%{fillup_and_insserv cyrus}

%postun
%insserv_cleanup

%files
%config(noreplace) /etc/imapd.conf
%config(noreplace) /etc/cyrus.conf
%dir /var/lib/imap
/var/lib/imap/deliverdb
/var/lib/imap/log
/var/lib/imap/msg
/var/lib/imap/proc
/var/lib/imap/quota
/var/lib/imap/user
/var/lib/imap/socket
/var/lib/imap/db
/var/lib/sieve
/etc/init.d/cyrus
/sbin/rccyrus
/usr/lib/cyrus
/usr/bin/cyradm
/usr/bin/imtest
/var/spool/imap
%doc %{_mandir}/man1/cyradm.1.gz
%doc %{_mandir}/man1/imtest.1.gz
%doc %{_mandir}/man1/installsieve.1.gz
%doc %{_mandir}/man3/imclient.3.gz
%doc %{_mandir}/man5/cyrus.conf.5.gz
%doc %{_mandir}/man5/imapd.conf.5.gz
%doc %{_mandir}/man5/krb.equiv.5.gz
%doc %{_mandir}/man8/arbitron.8.gz
%doc %{_mandir}/man8/collectnews.8.gz
%doc %{_mandir}/man8/ctl_deliver.8.gz
%doc %{_mandir}/man8/ctl_mboxlist.8.gz
%doc %{_mandir}/man8/deliver.8.gz
%doc %{_mandir}/man8/fud.8.gz
%doc %{_mandir}/man8/idled.8.gz
%doc %{_mandir}/man8/imapd.8.gz
%doc %{_mandir}/man8/ipurge.8.gz
%doc %{_mandir}/man8/lmtpd.8.gz
%doc %{_mandir}/man8/cyrus_master.8.gz
%doc %{_mandir}/man8/mbpath.8.gz
%doc %{_mandir}/man8/pop3d.8.gz
%doc %{_mandir}/man8/quota.8.gz
%doc %{_mandir}/man8/reconstruct.8.gz
%doc %{_mandir}/man8/rmnews.8.gz
%doc %{_mandir}/man8/syncnews.8.gz
%doc %{_mandir}/man8/timsieved.8.gz
%doc COPYRIGHT README README.andrew doc 
%doc SuSE/README.SuSE

%files -n cyrus-imapd-devel
/usr/include/cyrus
/usr/lib/libacap.a
/usr/lib/libcyrus.a

%files -n perl-Cyrus-IMAP
/usr/lib/perl5/site_perl/5.*/*-linux/Cyrus/IMAP
/usr/lib/perl5/site_perl/5.*/*-linux/Cyrus/IMAP.pm
/usr/lib/perl5/site_perl/5.*/*-linux/auto/Cyrus/IMAP
/var/adm/perl-modules/perl-Cyrus-IMAP
%doc %{_mandir}/man3/Cyrus::IMAP.3pm.gz
%doc %{_mandir}/man3/Cyrus::IMAP::Admin.3pm.gz
%doc %{_mandir}/man3/Cyrus::IMAP::Shell.3pm.gz

%files -n perl-Cyrus-SIEVE-acap
/usr/lib/perl5/site_perl/5.*/*-linux/Cyrus/SIEVE/acap.pm
/usr/lib/perl5/site_perl/5.*/*-linux/auto/Cyrus/SIEVE/acap
/var/adm/perl-modules/perl-Cyrus-SIEVE-acap
%doc %{_mandir}/man3/Cyrus::SIEVE::acap.3pm.gz

%files -n perl-Cyrus-SIEVE-managesieve
/usr/lib/perl5/site_perl/5.*/*-linux/Cyrus/SIEVE/managesieve.pm
/usr/lib/perl5/site_perl/5.*/*-linux/auto/Cyrus/SIEVE/managesieve
/var/adm/perl-modules/perl-Cyrus-SIEVE-managesieve
%doc %{_mandir}/man3/Cyrus::SIEVE::managesieve.3pm.gz

%changelog -n cyrus-imapd
* Fri Dec 06 2002 - choeger@suse.de
- Security update: The cyrus imapd contains a remotely exploitable
  buffer overflow before authentication takes place. This bug may
  be triggered by generating oversized error messages via SIEVE
  scripts.
* Wed Apr 17 2002 - choeger@suse.de
- bugfix for the vacation segv problem:
  cmd buffer in send_response(imap/lmtpd.c) has not been
  increased to fit the sendmail command in
* Mon Feb 25 2002 - choeger@suse.de
- Bugfix for a header parsing bug in SIEVE
  (http://asg.web.cmu.edu/archive/message.php?mailbox=archive.info-cyrus&searchterm=haferkamp&msg=12745)
* Fri Feb 22 2002 - choeger@suse.de
- made authid_normalize configurable
* Wed Feb 20 2002 - choeger@suse.de
- remove leading and trailing spaces from authid
  combined with authid_tolower -> authid_normalize
* Mon Feb 11 2002 - choeger@suse.de
- made allow_auth_plain_proxying configurable
* Fri Feb 01 2002 - choeger@suse.de
- modify /etc/services in %%post and exchange whatever
  uses port 2222 with sieve (Bugzilla ID#12922)
* Thu Jan 31 2002 - ro@suse.de
- added heimdal-lib to neededforbuild
* Tue Jan 22 2002 - ro@suse.de
- fix to build with db4
- bzipped source
* Tue Jan 15 2002 - choeger@suse.de
- added %%post section to handle updates from older
  SuSE Linux versions
* Tue Dec 11 2001 - choeger@suse.de
- FHS-enable
  /usr/cyrus -> /usr/lib/cyrus
  /usr/sieve -> /var/lib/sieve
  /var/imap  -> /var/lib/imap
- Bugfix: anonymous login possible, even if it is switched off
  Bugzilla ID#12585
* Fri Nov 30 2001 - choeger@suse.de
- remove START_ variable
* Mon Nov 19 2001 - choeger@suse.de
- added ipurge_force_all.patch
  ipurge only deletes mail in shared folders and not in folders
  below user.* and INBOX.*
  This patch adds -f option to allow *force* deletion of mail
  in all folders, see also
  http://asg.web.cmu.edu/archive/message.php?mailbox=archive.info-cyrus&msg=10166
  http://asg.web.cmu.edu/archive/message.php?mailbox=archive.info-cyrus&msg=10168
- Bugfix: drac patch was not applied because the configure
  script does not set DRAC_AUTH
- updated README.SuSE
- added ipurge example to cyrus.conf
* Wed Sep 05 2001 - choeger@suse.de
- added sieve_dotstuffing_fix
  See
  http://asg.web.cmu.edu/archive/message.php?mailbox=archive.info-cyrus&msg=10136
  for more details
* Fri Aug 17 2001 - choeger@suse.de
- added -u root to startproc options
  for some strange reasons cyrus isn't able to read root.root owned
  files after booting into system. -u root "fixes" this.
* Tue Aug 07 2001 - choeger@suse.de
- update to 2.0.16  (important db3 fixes)
* Wed Jul 11 2001 - choeger@suse.de
- update to 2.0.15 (sig11 fixes)
* Thu Jun 28 2001 - choeger@suse.de
- bugfix: init script was not LSB compliant, Bugzilla ID#8983
* Fri Jun 15 2001 - choeger@suse.de
- update to version 2.0.14
* Mon May 28 2001 - choeger@suse.de
- little fix: Leave Returnpath empty, if it is already empty
* Wed May 16 2001 - lmuelle@suse.de
- remove obsolete mail notify
* Thu Apr 19 2001 - choeger@suse.de
- renamed master to cyrus_master to prevent conflict
  with postfix master.8 manpage
* Mon Apr 02 2001 - choeger@suse.de
- added missing fillup to %%post :-(
* Tue Feb 27 2001 - ro@suse.de
- changed neededforbuild <cyrus-sasl> to <cyrus-sasl cyrus-sasl-devel>
* Wed Feb 21 2001 - choeger@suse.de
- new version, 2.0.12
* Thu Feb 01 2001 - choeger@suse.de
- new version 2.0.11 (bugfix release)
* Mon Jan 22 2001 - schwab@suse.de
- Compile with -fPIC for inclusion in shared library.
* Wed Dec 27 2000 - choeger@suse.de
- typo fix in README.SuSE
- new version 2.0.9 (Bugfix Release)
* Mon Dec 18 2000 - choeger@suse.de
- added README.SuSE
* Mon Dec 18 2000 - choeger@suse.de
- bugfix: Dependencies
- bugfix: openssl to neededforbuilt
* Sat Dec 09 2000 - kukuk@suse.de
- Fix group tags
* Thu Dec 07 2000 - choeger@suse.de
- added init script for new cyrus master daemon
  was not able to test it, yet
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <tcld> to <tcl-devel>
* Fri Nov 24 2000 - ro@suse.de
- neededforbuild += openssl-devel
* Tue Nov 21 2000 - choeger@suse.de
- new version 2.0.7
- build root
- long package name
* Mon Nov 20 2000 - ro@suse.de
- removed eazy from neededforbuild
* Thu Nov 16 2000 - ro@suse.de
- fixed neededforbuild
* Wed Oct 25 2000 - choeger@suse.de
- fixed drac support
* Fri Oct 20 2000 - choeger@suse.de
- hacked in support for DRAC
* Wed Oct 04 2000 - choeger@suse.de
- changed the behaviour of quota command
-t user.<uname> now prints the quota usage of this
  user to STDOUT
* Mon Sep 25 2000 - choeger@suse.de
- bugfix: /etc/imapd.conf was mode 755 ... :-(
* Sun Jun 18 2000 - ro@suse.de
- regenerate bison-files
* Fri Jun 09 2000 - choeger@suse.de
- update to version 1.6.24
- excluded sasl and made separate package
- no longer need for pwcheck with ldap support,
  we are using pam_ldap, now
* Wed May 24 2000 - choeger@suse.de
- patch by jro to the false double-subscribe behaviour
* Mon May 22 2000 - choeger@suse.de
- there's no tail in inst-sys, so we have to use sed instead
* Mon May 22 2000 - choeger@suse.de
- added reiserfs-check before calling chattr in postinstall
* Thu Apr 27 2000 - choeger@suse.de
- added new config option use-unix to pwcheck.conf
- changed auth sequence from unix->ldap to ldap->unix
* Tue Mar 14 2000 - choeger@suse.de
- mnt/usr/bin/chattr does not work, so we call
  chroot . /usr/bin/chattr
* Mon Mar 13 2000 - choeger@suse.de
- security fix in pwcheck-module
* Fri Mar 10 2000 - choeger@suse.de
- chattr is not in inst-sys, so we call
  mnt/usr/bin/chattr
* Wed Mar 01 2000 - choeger@suse.de
- added %%{_mandir}
* Thu Feb 17 2000 - choeger@suse.de
- updated to version 1.5.19 of cyrus-imapd
* Tue Jan 04 2000 - choeger@suse.de
- bugfix for pwcheck
* Thu Nov 11 1999 - choeger@suse.de
- added mail-notification to postinstall
* Tue Oct 12 1999 - ro@suse.de
- added tcld to neededforbuild
* Tue Sep 28 1999 - choeger@suse.de
- first version
